apiVersion: argoproj.io/v1alpha1
kind: Application
metadata:
  name: argocd
  annotations:
    argocd.argoproj.io/sync-wave: "0"
spec:
  destination:
    namespace: argocd
    server: https://kubernetes.default.svc
  project: default
  source:
    chart: argo-cd
    repoURL: https://argoproj.github.io/argo-helm
    targetRevision: 3.35.0
    helm:
      values: |
        ## ArgoCD configuration
        ## Ref: https://github.com/argoproj/argo-cd
        ##
        ## Configs
        configs:
          credentialTemplates:
            ssh-creds:
              url: ssh://git@gitlab-gitlab-shell.gitlab.svc.cluster.local:32022/gitops
          repositories:
            argocd-helm-repo:
              url: https://argoproj.github.io/argo-helm
              name: argo-helm
              type: helm
            gitlab-local-repo:
              name: gitlab.local
              url: ssh://git@gitlab-gitlab-shell.gitlab.svc.cluster.local:32022/gitops/argocd.git
        ## Server
        server:
          ingress:
              enabled: true
              ingressClassName: nginx
              annotations:
                ingress.kubernetes.io/rewrite-target: /
                nginx.ingress.kubernetes.io/backend-protocol: "HTTPS"
                nginx.ingress.kubernetes.io/force-ssl-redirect: "true"
                cert-manager.io/cluster-issuer: ca-issuer
              hosts:
                - argocd.local
              paths:
                - /
              pathType: Prefix
              tls:
                - secretName: argocd-cert-tls
                  hosts:
                    - argocd.local
              https: true
          ## ArgoCD config
          ## reference https://github.com/argoproj/argo-cd/blob/master/docs/operator-manual/argocd-cm.yaml
          configEnabled: true
          additionalApplications: 
            - name: apps
              namespace: argocd
              destination:
                namespace: argocd
                server: https://kubernetes.default.svc
              project: default
              source:
                path: apps
                repoURL: ssh://git@gitlab-gitlab-shell.gitlab.svc.cluster.local:32022/gitops/argocd.git
                targetRevision: HEAD
                directory:
                  recurse: true
                  jsonnet: {}
              syncPolicy:
                automated:
                  selfHeal: true
                  prune: true
            - name: projects
              namespace: argocd
              destination:
                namespace: argocd
                server: https://kubernetes.default.svc
              project: default
              source:
                path: projects
                repoURL: ssh://git@gitlab-gitlab-shell.gitlab.svc.cluster.local:32022/gitops/argocd.git
                targetRevision: HEAD
                directory:
                  recurse: true
                  jsonnet: {}
              syncPolicy:
                automated:
                  selfHeal: true
                  prune: true
  syncPolicy:
    automated: {}
    syncOptions:
      - CreateNamespace=true